Index: uspace/app/bnchmark/bnchmark.c
===================================================================
--- uspace/app/bnchmark/bnchmark.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/bnchmark/bnchmark.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <stdlib.h>
 #include <stdint.h>
-#include <str_error.h>
 #include <mem.h>
 #include <loc.h>
@@ -49,5 +48,4 @@
 #include <time.h>
 #include <dirent.h>
-#include <str.h>
 
 #define NAME	"bnchmark"
@@ -55,15 +53,15 @@
 #define MBYTE (1024*1024)
 
-typedef errno_t(*measure_func_t)(void *);
+typedef int(*measure_func_t)(void *);
 typedef unsigned long umseconds_t; /* milliseconds */
 
 static void syntax_print(void);
 
-static errno_t measure(measure_func_t fn, void* data, umseconds_t *result)
+static int measure(measure_func_t fn, void* data, umseconds_t *result)
 {
 	struct timeval start_time;
 	gettimeofday(&start_time, NULL);
 	
-	errno_t rc = fn(data);
+	int rc = fn(data);
 	if (rc != EOK) {
 		fprintf(stderr, "measured function failed\n");
@@ -80,5 +78,5 @@
 }
 
-static errno_t sequential_read_file(void *data)
+static int sequential_read_file(void *data)
 {
 	char *path = (char *) data;
@@ -110,5 +108,5 @@
 }
 
-static errno_t sequential_read_dir(void *data)
+static int sequential_read_dir(void *data)
 {
 	char *path = (char *) data;
@@ -132,5 +130,5 @@
 int main(int argc, char **argv)
 {
-	errno_t rc;
+	int rc;
 	umseconds_t milliseconds_taken = 0;
 	char *path = NULL;
@@ -188,5 +186,5 @@
 		rc = measure(fn, path, &milliseconds_taken);
 		if (rc != EOK) {
-			fprintf(stderr, "Error: %s\n", str_error(rc));
+			fprintf(stderr, "Error %d\n", rc);
 			return 1;
 		}
Index: uspace/app/corecfg/corecfg.c
===================================================================
--- uspace/app/corecfg/corecfg.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/corecfg/corecfg.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <errno.h>
 #include <stdio.h>
-#include <str.h>
 
 #define NAME "corecfg"
@@ -51,5 +50,5 @@
 {
 	bool enable;
-	errno_t rc;
+	int rc;
 
 	rc = corecfg_get_enable(&enable);
@@ -66,5 +65,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	rc = corecfg_init();
Index: uspace/app/date/date.c
===================================================================
--- uspace/app/date/date.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/date/date.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,11 +36,10 @@
 #include <getopt.h>
 #include <ctype.h>
-#include <str.h>
 
 #define NAME   "date"
 
-static errno_t read_date_from_arg(char *wdate, struct tm *t);
-static errno_t read_time_from_arg(char *wdate, struct tm *t);
-static errno_t tm_sanity_check(struct tm *t);
+static int read_date_from_arg(char *wdate, struct tm *t);
+static int read_time_from_arg(char *wdate, struct tm *t);
+static int tm_sanity_check(struct tm *t);
 static bool is_leap_year(int year);
 
@@ -52,6 +51,5 @@
 main(int argc, char **argv)
 {
-	errno_t rc;
-	int c;
+	int rc, c;
 	category_id_t cat_id;
 	size_t        svc_cnt;
@@ -198,8 +196,8 @@
  *  with the following format: DD/MM/YYYY
  */
-static errno_t
+static int
 read_date_from_arg(char *wdate, struct tm *t)
 {
-	errno_t rc;
+	int rc;
 	uint32_t tmp;
 
@@ -233,8 +231,8 @@
  *  with the following format: HH:MM:SS or HH:MM
  */
-static errno_t
+static int
 read_time_from_arg(char *wtime, struct tm *t)
 {
-	errno_t rc;
+	int rc;
 	size_t len = str_size(wtime);
 	bool sec_present = len == 8;
@@ -279,5 +277,5 @@
  * @return      EOK on success or EINVAL
  */
-static errno_t
+static int
 tm_sanity_check(struct tm *t)
 {
Index: uspace/app/devctl/devctl.c
===================================================================
--- uspace/app/devctl/devctl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/devctl/devctl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -71,5 +70,5 @@
 }
 
-static errno_t fun_subtree_print(devman_handle_t funh, int lvl)
+static int fun_subtree_print(devman_handle_t funh, int lvl)
 {
 	devman_handle_t devh;
@@ -77,5 +76,5 @@
 	size_t count, i;
 	unsigned int score;
-	errno_t rc;
+	int rc;
 	int j;
 
@@ -137,8 +136,8 @@
 }
 
-static errno_t fun_tree_print(void)
+static int fun_tree_print(void)
 {
 	devman_handle_t root_fun;
-	errno_t rc;
+	int rc;
 
 	rc = devman_fun_get_handle("/", &root_fun, 0);
@@ -155,8 +154,8 @@
 }
 
-static errno_t fun_online(const char *path)
+static int fun_online(const char *path)
 {
 	devman_handle_t funh;
-	errno_t rc;
+	int rc;
 
 	rc = devman_fun_get_handle(path, &funh, 0);
@@ -176,8 +175,8 @@
 }
 
-static errno_t fun_offline(const char *path)
+static int fun_offline(const char *path)
 {
 	devman_handle_t funh;
-	errno_t rc;
+	int rc;
 
 	rc = devman_fun_get_handle(path, &funh, 0);
@@ -198,5 +197,5 @@
 }
 
-static errno_t drv_list(void)
+static int drv_list(void)
 {
 	devman_handle_t *devs;
@@ -208,5 +207,5 @@
 	size_t i;
 	table_t *table = NULL;
-	errno_t rc;
+	int rc;
 
 	rc = devman_get_drivers(&drvs, &ndrvs);
@@ -253,5 +252,5 @@
 }
 
-static errno_t drv_show(char *drvname)
+static int drv_show(char *drvname)
 {
 	devman_handle_t *devs;
@@ -263,5 +262,5 @@
 	size_t ndevs;
 	size_t i;
-	errno_t rc;
+	int rc;
 
 	rc = devman_driver_get_handle(drvname, &drvh);
@@ -318,12 +317,12 @@
 }
 
-static errno_t drv_load(const char *drvname)
-{
-	errno_t rc;
+static int drv_load(const char *drvname)
+{
+	int rc;
 	devman_handle_t drvh;
 
 	rc = devman_driver_get_handle(drvname, &drvh);
 	if (rc != EOK) {
-		printf("Failed resolving driver '%s': %s.\n", drvname, str_error(rc));
+		printf("Failed resolving driver '%s' (%d).\n", drvname, rc);
 		return rc;
 	}
@@ -331,19 +330,19 @@
 	rc = devman_driver_load(drvh);
 	if (rc != EOK) {
-		printf("Failed loading driver '%s': %s.\n", drvname, str_error(rc));
-		return rc;
-	}
-
-	return EOK;
-}
-
-static errno_t drv_unload(const char *drvname)
-{
-	errno_t rc;
+		printf("Failed loading driver '%s' (%d).\n", drvname, rc);
+		return rc;
+	}
+
+	return EOK;
+}
+
+static int drv_unload(const char *drvname)
+{
+	int rc;
 	devman_handle_t drvh;
 
 	rc = devman_driver_get_handle(drvname, &drvh);
 	if (rc != EOK) {
-		printf("Failed resolving driver '%s': %s.\n", drvname, str_error(rc));
+		printf("Failed resolving driver '%s' (%d).\n", drvname, rc);
 		return rc;
 	}
@@ -351,5 +350,5 @@
 	rc = devman_driver_unload(drvh);
 	if (rc != EOK) {
-		printf("Failed unloading driver '%s': %s.\n", drvname, str_error(rc));
+		printf("Failed unloading driver '%s' (%d).\n", drvname, rc);
 		return rc;
 	}
@@ -372,5 +371,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	if (argc == 1 || argv[1][0] == '-') {
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/df/df.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,7 +56,7 @@
 static bool display_blocks;
 
-static errno_t size_to_human_readable(uint64_t, size_t, char **);
+static int size_to_human_readable(uint64_t, size_t, char **);
 static void print_header(void);
-static errno_t print_statfs(vfs_statfs_t *, char *, char *);
+static int print_statfs(struct statfs *, char *, char *);
 static void print_usage(void);
 
@@ -64,6 +64,6 @@
 {
 	int optres, errflg = 0;
-	vfs_statfs_t st;
-	errno_t rc;
+	struct statfs st;
+	int rc;
 
 	display_blocks = false;
@@ -128,5 +128,5 @@
 }
 
-static errno_t size_to_human_readable(uint64_t nblocks, size_t block_size, char **rptr)
+static int size_to_human_readable(uint64_t nblocks, size_t block_size, char **rptr)
 {
 	cap_spec_t cap;
@@ -147,10 +147,10 @@
 }
 
-static errno_t print_statfs(vfs_statfs_t *st, char *name, char *mountpoint)
+static int print_statfs(struct statfs *st, char *name, char *mountpoint)
 {
 	uint64_t const used_blocks = st->f_blocks - st->f_bfree;
 	unsigned const perc_used = PERCENTAGE(used_blocks, st->f_blocks);
 	char *str;
-	errno_t rc;
+	int rc;
 
 	printf("%10s", name);
Index: uspace/app/dltest/dltest.c
===================================================================
--- uspace/app/dltest/dltest.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/dltest/dltest.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 /** libdltest library handle */
Index: uspace/app/dnscfg/dnscfg.c
===================================================================
--- uspace/app/dnscfg/dnscfg.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/dnscfg/dnscfg.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,4 @@
 #include <stdlib.h>
 #include <stdint.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -56,5 +55,5 @@
 }
 
-static errno_t dnscfg_set_ns(int argc, char *argv[])
+static int dnscfg_set_ns(int argc, char *argv[])
 {
 	if (argc < 1) {
@@ -73,5 +72,5 @@
 	
 	inet_addr_t addr;
-	errno_t rc = inet_addr_parse(srv_addr, &addr, NULL);
+	int rc = inet_addr_parse(srv_addr, &addr, NULL);
 	
 	if (rc != EOK) {
@@ -90,10 +89,10 @@
 }
 
-static errno_t dnscfg_unset_ns(void)
+static int dnscfg_unset_ns(void)
 {
 	inet_addr_t addr;
 	inet_addr_any(&addr);
 	
-	errno_t rc = dnsr_set_srvaddr(&addr);
+	int rc = dnsr_set_srvaddr(&addr);
 	if (rc != EOK) {
 		printf("%s: Failed unsetting server address (%s)\n",
@@ -105,8 +104,8 @@
 }
 
-static errno_t dnscfg_print(void)
+static int dnscfg_print(void)
 {
 	inet_addr_t addr;
-	errno_t rc = dnsr_get_srvaddr(&addr);
+	int rc = dnsr_get_srvaddr(&addr);
 	if (rc != EOK) {
 		printf("%s: Failed getting DNS server address.\n", NAME);
Index: uspace/app/dnsres/dnsres.c
===================================================================
--- uspace/app/dnsres/dnsres.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/dnsres/dnsres.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 
 #define NAME  "dnsres"
@@ -79,5 +78,5 @@
 	
 	dnsr_hostinfo_t *hinfo;
-	errno_t rc = dnsr_name2host(hname, &hinfo, ver);
+	int rc = dnsr_name2host(hname, &hinfo, ver);
 	if (rc != EOK) {
 		printf("%s: Error resolving '%s'.\n", NAME, hname);
Index: uspace/app/download/main.c
===================================================================
--- uspace/app/download/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/download/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,6 +73,5 @@
 	uri_t *uri = NULL;
 	http_t *http = NULL;
-	errno_t rc;
-	int ret;
+	int rc;
 
 	if (argc < 2) {
@@ -156,6 +155,6 @@
 		}
 	} else {
-		ret = asprintf(&server_path, "%s?%s", path, uri->query);
-		if (ret < 0) {
+		rc = asprintf(&server_path, "%s?%s", path, uri->query);
+		if (rc < 0) {
 			fprintf(stderr, "Failed allocating path\n");
 			rc = ENOMEM;
@@ -230,6 +229,6 @@
 		}
 		
-		if (rc != EOK) {
-			fprintf(stderr, "Failed receiving body: %s", str_error(rc));
+		if (body_size != 0) {
+			fprintf(stderr, "Failed receiving body: %s", str_error(body_size));
 		}
 	}
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/edit.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -132,8 +132,8 @@
 static void pos_handle(pos_event_t *ev);
 
-static errno_t file_save(char const *fname);
+static int file_save(char const *fname);
 static void file_save_as(void);
-static errno_t file_insert(char *fname);
-static errno_t file_save_range(char const *fname, spt_t const *spos,
+static int file_insert(char *fname);
+static int file_save_range(char const *fname, spt_t const *spos,
     spt_t const *epos);
 static char *range_get_str(spt_t const *spos, spt_t const *epos);
@@ -191,5 +191,5 @@
 	cons_event_t ev;
 	bool new_file;
-	errno_t rc;
+	int rc;
 
 	con = console_init(stdin, stdout);
@@ -578,8 +578,8 @@
 
 /** Save the document. */
-static errno_t file_save(char const *fname)
+static int file_save(char const *fname)
 {
 	spt_t sp, ep;
-	errno_t rc;
+	int rc;
 
 	status_display("Saving...");
@@ -616,5 +616,5 @@
 	}
 
-	errno_t rc = file_save(fname);
+	int rc = file_save(fname);
 	if (rc != EOK)
 		return;
@@ -697,5 +697,5 @@
  * of the caret.
  */
-static errno_t file_insert(char *fname)
+static int file_insert(char *fname)
 {
 	FILE *f;
@@ -735,5 +735,5 @@
 
 /** Save a range of text into a file. */
-static errno_t file_save_range(char const *fname, spt_t const *spos,
+static int file_save_range(char const *fname, spt_t const *spos,
     spt_t const *epos)
 {
@@ -761,5 +761,5 @@
 	} while (!spt_equal(&bep, epos));
 
-	if (fclose(f) < 0)
+	if (fclose(f) != EOK)
 		return EIO;
 
@@ -1283,5 +1283,5 @@
 
 /* Search operations */
-static errno_t search_spt_producer(void *data, wchar_t *ret)
+static int search_spt_producer(void *data, wchar_t *ret)
 {
 	assert(data != NULL);
@@ -1292,5 +1292,5 @@
 }
 
-static errno_t search_spt_reverse_producer(void *data, wchar_t *ret)
+static int search_spt_reverse_producer(void *data, wchar_t *ret)
 {
 	assert(data != NULL);
@@ -1301,5 +1301,5 @@
 }
 
-static errno_t search_spt_mark(void *data, void **mark)
+static int search_spt_mark(void *data, void **mark)
 {
 	assert(data != NULL);
@@ -1397,5 +1397,5 @@
 	
 	match_t match;
-	errno_t rc = search_next_match(search, &match);
+	int rc = search_next_match(search, &match);
 	if (rc != EOK) {
 		status_display("Failed searching.");
@@ -1515,5 +1515,5 @@
 	size_t off;
 	wchar_t c;
-	errno_t rc;
+	int rc;
 
 	rc = clipboard_get_str(&str);
Index: uspace/app/edit/search.c
===================================================================
--- uspace/app/edit/search.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/search.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -105,10 +105,10 @@
 }
 
-errno_t search_next_match(search_t *s, match_t *match)
+int search_next_match(search_t *s, match_t *match)
 {
 	search_equals_fn eq = s->ops.equals;
 	
 	wchar_t cur_char;
-	errno_t rc = EOK;
+	int rc = EOK;
 	while ((rc = s->ops.producer(s->client_data, &cur_char)) == EOK && cur_char > 0) {
 		/* Deal with mismatches */
Index: uspace/app/edit/search.h
===================================================================
--- uspace/app/edit/search.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/search.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,6 +43,6 @@
 typedef struct search search_t;
 typedef bool (*search_equals_fn)(const wchar_t, const wchar_t);
-typedef errno_t (*search_producer_fn)(void *, wchar_t *);
-typedef errno_t (*search_mark_fn)(void *, void **);
+typedef int (*search_producer_fn)(void *, wchar_t *);
+typedef int (*search_mark_fn)(void *, void **);
 typedef void (*search_mark_free_fn)(void *);
 
@@ -61,5 +61,5 @@
 extern bool char_exact_equals(const wchar_t, const wchar_t);
 extern search_t *search_init(const char *, void *, search_ops_t, bool);
-extern errno_t search_next_match(search_t *, match_t *);
+extern int search_next_match(search_t *, match_t *);
 extern void search_fini(search_t *);
 
Index: uspace/app/edit/search_impl.h
===================================================================
--- uspace/app/edit/search_impl.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/search_impl.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 	/* Note: This structure is opaque for the user. */
 
-	wchar_t *pattern;
+	const wchar_t *pattern;
 	size_t pattern_length;
 	ssize_t *back_table;
Index: uspace/app/edit/sheet.c
===================================================================
--- uspace/app/edit/sheet.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/sheet.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,5 +67,5 @@
 
 /** Initialize an empty sheet. */
-errno_t sheet_create(sheet_t **rsh)
+int sheet_create(sheet_t **rsh)
 {
 	sheet_t *sh;
@@ -95,5 +95,5 @@
  * @param str	The text to insert (printable characters, tabs, newlines).
  *
- * @return	EOK on success or an error code.
+ * @return	EOK on success or negative error code.
  *
  * @note	@a dir affects which way tags that were placed on @a pos will
@@ -101,5 +101,5 @@
  *		and vice versa.
  */
-errno_t sheet_insert(sheet_t *sh, spt_t *pos, enum dir_spec dir, char *str)
+int sheet_insert(sheet_t *sh, spt_t *pos, enum dir_spec dir, char *str)
 {
 	char *ipp;
@@ -145,7 +145,7 @@
  * @param epos	Ending point.
  *
- * @return	EOK on success or an error code.
+ * @return	EOK on success or negative error code.
  **/
-errno_t sheet_delete(sheet_t *sh, spt_t *spos, spt_t *epos)
+int sheet_delete(sheet_t *sh, spt_t *spos, spt_t *epos)
 {
 	char *spp;
Index: uspace/app/edit/sheet.h
===================================================================
--- uspace/app/edit/sheet.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/edit/sheet.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -90,7 +90,7 @@
 } tag_t;
 
-extern errno_t sheet_create(sheet_t **);
-extern errno_t sheet_insert(sheet_t *, spt_t *, enum dir_spec, char *);
-extern errno_t sheet_delete(sheet_t *, spt_t *, spt_t *);
+extern int sheet_create(sheet_t **);
+extern int sheet_insert(sheet_t *, spt_t *, enum dir_spec, char *);
+extern int sheet_delete(sheet_t *, spt_t *, spt_t *);
 extern void sheet_copy_out(sheet_t *, spt_t const *, spt_t const *, char *,
     size_t, spt_t *);
Index: uspace/app/fdisk/fdisk.c
===================================================================
--- uspace/app/fdisk/fdisk.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/fdisk/fdisk.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <stdlib.h>
 #include <fdisk.h>
-#include <str.h>
 
 #define NO_LABEL_CAPTION "(No name)"
@@ -69,8 +68,8 @@
 } devac_t;
 
-static errno_t fdsk_pcnt_fs_format(vol_part_cnt_t pcnt, vol_fstype_t fstype,
+static int fdsk_pcnt_fs_format(vol_part_cnt_t pcnt, vol_fstype_t fstype,
     char **rstr)
 {
-	errno_t rc;
+	int rc;
 	char *s;
 
@@ -98,9 +97,9 @@
 
 /** Confirm user selection. */
-static errno_t fdsk_confirm(const char *msg, bool *rconfirm)
+static int fdsk_confirm(const char *msg, bool *rconfirm)
 {
 	tinput_t *tinput = NULL;
 	char *answer;
-	errno_t rc;
+	int rc;
 
 	tinput = tinput_new();
@@ -147,5 +146,5 @@
 
 /** Device selection */
-static errno_t fdsk_dev_sel_choice(service_id_t *rsvcid)
+static int fdsk_dev_sel_choice(service_id_t *rsvcid)
 {
 	fdisk_dev_list_t *devlist = NULL;
@@ -160,5 +159,5 @@
 	void *sel;
 	int ndevs;
-	errno_t rc;
+	int rc;
 
 	rc = nchoice_create(&choice);
@@ -211,6 +210,6 @@
 		}
 
-		int ret = asprintf(&dtext, "%s (%s)", svcname, scap);
-		if (ret < 0) {
+		rc = asprintf(&dtext, "%s (%s)", svcname, scap);
+		if (rc < 0) {
 			rc = ENOMEM;
 			printf("Out of memory.\n");
@@ -270,6 +269,4 @@
 	return EOK;
 error:
-	assert(rc != EOK);
-	*rsvcid = 0;
 	if (devlist != NULL)
 		fdisk_dev_list_free(devlist);
@@ -282,5 +279,5 @@
 }
 
-static errno_t fdsk_create_label(fdisk_dev_t *dev)
+static int fdsk_create_label(fdisk_dev_t *dev)
 {
 	nchoice_t *choice = NULL;
@@ -288,5 +285,5 @@
 	char *sltype = NULL;
 	int i;
-	errno_t rc;
+	int rc;
 
 	rc = nchoice_create(&choice);
@@ -342,8 +339,8 @@
 }
 
-static errno_t fdsk_delete_label(fdisk_dev_t *dev)
+static int fdsk_delete_label(fdisk_dev_t *dev)
 {
 	bool confirm;
-	errno_t rc;
+	int rc;
 
 	rc = fdsk_confirm("Warning. Any data on disk will be lost. "
@@ -366,8 +363,8 @@
 }
 
-static errno_t fdsk_erase_disk(fdisk_dev_t *dev)
+static int fdsk_erase_disk(fdisk_dev_t *dev)
 {
 	bool confirm;
-	errno_t rc;
+	int rc;
 
 	rc = fdsk_confirm("Warning. Any data on disk will be lost. "
@@ -390,5 +387,5 @@
 }
 
-static errno_t fdsk_select_fstype(vol_fstype_t *fstype)
+static int fdsk_select_fstype(vol_fstype_t *fstype)
 {
 	nchoice_t *choice = NULL;
@@ -396,5 +393,5 @@
 	char *sfstype;
 	int i;
-	errno_t rc;
+	int rc;
 
 	rc = nchoice_create(&choice);
@@ -445,7 +442,7 @@
 }
 
-static errno_t fdsk_create_part(fdisk_dev_t *dev, label_pkind_t pkind)
+static int fdsk_create_part(fdisk_dev_t *dev, label_pkind_t pkind)
 {
-	errno_t rc;
+	int rc;
 	fdisk_part_spec_t pspec;
 	cap_spec_t cap;
@@ -554,5 +551,5 @@
 }
 
-static errno_t fdsk_delete_part(fdisk_dev_t *dev)
+static int fdsk_delete_part(fdisk_dev_t *dev)
 {
 	nchoice_t *choice = NULL;
@@ -566,5 +563,5 @@
 	bool confirm;
 	void *sel;
-	errno_t rc;
+	int rc;
 
 	rc = nchoice_create(&choice);
@@ -616,7 +613,7 @@
 				label = "(No name)";
 
-			int ret = asprintf(&sdesc, "%s %s, %s, %s", label,
+			rc = asprintf(&sdesc, "%s %s, %s, %s", label,
 			    scap, spkind, sfstype);
-			if (ret < 0) {
+			if (rc < 0) {
 				rc = ENOMEM;
 				goto error;
@@ -624,6 +621,6 @@
 
 		} else {
-			int ret = asprintf(&sdesc, "%s, %s", scap, spkind);
-			if (ret < 0) {
+			rc = asprintf(&sdesc, "%s, %s", scap, spkind);
+			if (rc < 0) {
 				rc = ENOMEM;
 				goto error;
@@ -701,5 +698,5 @@
 
 /** Device menu */
-static errno_t fdsk_dev_menu(fdisk_dev_t *dev)
+static int fdsk_dev_menu(fdisk_dev_t *dev)
 {
 	nchoice_t *choice = NULL;
@@ -718,5 +715,5 @@
 	char *spkind;
 	const char *label;
-	errno_t rc;
+	int rc;
 	int npart;
 	void *sel;
@@ -1080,5 +1077,5 @@
 	service_id_t svcid;
 	fdisk_dev_t *dev;
-	errno_t rc;
+	int rc;
 
 	rc = fdisk_create(&fdisk);
Index: uspace/app/fontviewer/fontviewer.c
===================================================================
--- uspace/app/fontviewer/fontviewer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/fontviewer/fontviewer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #include <stdlib.h>
 #include <stdbool.h>
-#include <str_error.h>
 #include <window.h>
 #include <canvas.h>
@@ -63,5 +62,5 @@
 char *font_path = NULL;
 
-static errno_t draw(void);
+static int draw(void);
 
 static void on_keyboard_event(widget_t *widget, void *data)
@@ -96,7 +95,7 @@
 	}
 	
-	errno_t rc = draw();
+	int rc = draw();
 	if (rc != EOK) {
-		printf("Failed drawing: %s.\n", str_error(rc));
+		printf("Failed drawing: %d.\n", rc);
 		exit(1);
 	}
@@ -104,5 +103,5 @@
 }
 
-static errno_t create_font(font_t **font, uint16_t points)
+static int create_font(font_t **font, uint16_t points)
 {
 	if (font_path == NULL) {
@@ -139,5 +138,5 @@
 
 static int text(drawctx_t *, font_t *, source_t *, surface_coord_t x,
-    surface_coord_t , const char *, ...) _HELENOS_PRINTF_ATTRIBUTE(6, 7);
+    surface_coord_t , const char *, ...) PRINTF_ATTRIBUTE(6, 7);
 static int text(drawctx_t *drawctx, font_t *font, source_t *source,
     surface_coord_t x, surface_coord_t y, const char *fmt, ...)
@@ -149,11 +148,12 @@
 	va_end(args);
 	
-	if (ret >= 0) {
-		drawctx_set_source(drawctx, source);
-		drawctx_set_font(drawctx, font);
-		drawctx_print(drawctx, str, x, y);
-
-		free(str);
-	}
+	if (ret <= 0)
+		return ret;
+	
+	drawctx_set_source(drawctx, source);
+	drawctx_set_font(drawctx, font);
+	drawctx_print(drawctx, str, x, y);
+	
+	free(str);
 	
 	return ret;
@@ -161,5 +161,5 @@
 
 
-static errno_t draw(void)
+static int draw(void)
 {
 	source_t background = rgb(255, 255, 255);
@@ -174,5 +174,5 @@
 	
 	font_t *font;
-	errno_t rc = create_font(&font, points);
+	int rc = create_font(&font, points);
 	if (rc != EOK) {
 		printf("Failed creating font\n");
@@ -274,7 +274,7 @@
 	height = WINDOW_HEIGHT;
 	
-	errno_t rc = draw();
+	int rc = draw();
 	if (rc != EOK) {
-		printf("Failed drawing: %s.\n", str_error(rc));
+		printf("Failed drawing: %d.\n", rc);
 		return 2;
 	}
Index: uspace/app/getterm/getterm.c
===================================================================
--- uspace/app/getterm/getterm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/getterm/getterm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <loc.h>
 #include <vfs/vfs.h>
-#include <str.h>
 #include "version.h"
 #include "welcome.h"
@@ -66,16 +65,12 @@
 	*stream = NULL;
 	
-	int oldfd;
-	errno_t rc = vfs_lookup_open(path, WALK_REGULAR, mode, &oldfd);
-	if (rc != EOK)
+	int oldfd = vfs_lookup_open(path, WALK_REGULAR, mode);
+	if (oldfd < 0)
 		return;
 	
 	if (oldfd != fd) {
-		int newfd;
-		if (vfs_clone(oldfd, fd, false, &newfd) != EOK)
+		if (vfs_clone(oldfd, fd, false) != fd)
 			return;
 		
-		assert(newfd == fd);
-
 		if (vfs_put(oldfd))
 			return;
@@ -134,5 +129,5 @@
 		/* Wait for the terminal service to be ready */
 		service_id_t service_id;
-		errno_t rc = loc_service_get_id(term, &service_id, IPC_FLAG_BLOCKING);
+		int rc = loc_service_get_id(term, &service_id, IPC_FLAG_BLOCKING);
 		if (rc != EOK) {
 			printf("%s: Error waiting on %s (%s)\n", APP_NAME, term,
@@ -171,5 +166,5 @@
 	task_wait_t twait;
 	
-	errno_t rc = task_spawnv(&id, &twait, cmd, (const char * const *) args);
+	int rc = task_spawnv(&id, &twait, cmd, (const char * const *) args);
 	if (rc != EOK) {
 		printf("%s: Error spawning %s (%s)\n", APP_NAME, cmd,
Index: uspace/app/gunzip/gunzip.c
===================================================================
--- uspace/app/gunzip/gunzip.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/gunzip/gunzip.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	void *data, *ddata;
 	size_t size, dsize;
@@ -58,5 +58,6 @@
 	}
 
-	if (fseek(f, 0, SEEK_END) < 0) {
+	rc = fseek(f, 0, SEEK_END);
+	if (rc != 0) {
 		printf("Error determining size of '%s'\n", argv[1]);
 		fclose(f);
@@ -71,5 +72,6 @@
 	}
 
-	if (fseek(f, 0, SEEK_SET) < 0) {
+	rc = fseek(f, 0, SEEK_SET);
+	if (rc != 0) {
 		printf ("Error rewinding '%s'\n", argv[1]);
 		fclose(f);
Index: uspace/app/inet/inet.c
===================================================================
--- uspace/app/inet/inet.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/inet/inet.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,4 @@
 #include <stdlib.h>
 #include <stdint.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -61,5 +60,5 @@
 }
 
-static errno_t addr_create_static(int argc, char *argv[])
+static int addr_create_static(int argc, char *argv[])
 {
 	char *aobj_name;
@@ -70,5 +69,5 @@
 	sysarg_t link_id;
 	sysarg_t addr_id;
-	errno_t rc;
+	int rc;
 
 	if (argc < 3) {
@@ -90,5 +89,5 @@
 	rc = loc_service_get_id(link_name, &link_id, 0);
 	if (rc != EOK) {
-		printf(NAME ": Service '%s' not found: %s.\n", link_name, str_error(rc));
+		printf(NAME ": Service '%s' not found (%d).\n", link_name, rc);
 		return ENOENT;
 	}
@@ -111,5 +110,5 @@
 }
 
-static errno_t addr_delete(int argc, char *argv[])
+static int addr_delete(int argc, char *argv[])
 {
 	char *aobj_name;
@@ -117,5 +116,5 @@
 	sysarg_t link_id;
 	sysarg_t addr_id;
-	errno_t rc;
+	int rc;
 
 	if (argc < 2) {
@@ -136,6 +135,5 @@
 	rc = loc_service_get_id(link_name, &link_id, 0);
 	if (rc != EOK) {
-		printf(NAME ": Service '%s' not found: %s.\n", link_name,
-		    str_error(rc));
+		printf(NAME ": Service '%s' not found (%d).\n", link_name, rc);
 		return ENOENT;
 	}
@@ -143,6 +141,5 @@
 	rc = inetcfg_addr_get_id(aobj_name, link_id, &addr_id);
 	if (rc != EOK) {
-		printf(NAME ": Address '%s' not found: %s.\n", aobj_name,
-		    str_error(rc));
+		printf(NAME ": Address '%s' not found (%d).\n", aobj_name, rc);
 		return ENOENT;
 	}
@@ -150,6 +147,6 @@
 	rc = inetcfg_addr_delete(addr_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed deleting address '%s': %s\n", aobj_name,
-		    str_error(rc));
+		printf(NAME ": Failed deleting address '%s' (%d)\n", aobj_name,
+		    rc);
 		return EIO;
 	}
@@ -158,5 +155,5 @@
 }
 
-static errno_t sroute_create(int argc, char *argv[])
+static int sroute_create(int argc, char *argv[])
 {
 	char *dest_str;
@@ -167,5 +164,5 @@
 	inet_addr_t router;
 	sysarg_t sroute_id;
-	errno_t rc;
+	int rc;
 
 	if (argc < 3) {
@@ -200,6 +197,6 @@
 	rc = inetcfg_sroute_create(route_name, &dest, &router, &sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed creating static route '%s': %s\n",
-		    route_name, str_error(rc));
+		printf(NAME ": Failed creating static route '%s' (%d)\n",
+		    route_name, rc);
 		return EIO;
 	}
@@ -208,9 +205,9 @@
 }
 
-static errno_t sroute_delete(int argc, char *argv[])
+static int sroute_delete(int argc, char *argv[])
 {
 	char *route_name;
 	sysarg_t sroute_id;
-	errno_t rc;
+	int rc;
 
 	if (argc < 1) {
@@ -230,6 +227,6 @@
 	rc = inetcfg_sroute_get_id(route_name, &sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Static route '%s' not found: %s.\n",
-		    route_name, str_error(rc));
+		printf(NAME ": Static route '%s' not found (%d).\n",
+		    route_name, rc);
 		return ENOENT;
 	}
@@ -237,6 +234,6 @@
 	rc = inetcfg_sroute_delete(sroute_id);
 	if (rc != EOK) {
-		printf(NAME ": Failed deleting static route '%s': %s\n",
-		    route_name, str_error(rc));
+		printf(NAME ": Failed deleting static route '%s' (%d)\n",
+		    route_name, rc);
 		return EIO;
 	}
@@ -245,5 +242,5 @@
 }
 
-static errno_t addr_list(void)
+static int addr_list(void)
 {
 	sysarg_t *addr_list;
@@ -254,5 +251,5 @@
 	size_t count;
 	size_t i;
-	errno_t rc;
+	int rc;
 	char *astr = NULL;
 
@@ -335,5 +332,5 @@
 }
 
-static errno_t link_list(void)
+static int link_list(void)
 {
 	sysarg_t *link_list = NULL;
@@ -343,5 +340,5 @@
 	size_t count;
 	size_t i;
-	errno_t rc;
+	int rc;
 
 	rc = inetcfg_get_link_list(&link_list, &count);
@@ -396,5 +393,5 @@
 }
 
-static errno_t sroute_list(void)
+static int sroute_list(void)
 {
 	sysarg_t *sroute_list = NULL;
@@ -404,5 +401,5 @@
 	size_t count;
 	size_t i;
-	errno_t rc;
+	int rc;
 	char *dest_str = NULL;
 	char *router_str = NULL;
@@ -485,10 +482,10 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 
 	rc = inetcfg_init();
 	if (rc != EOK) {
-		printf(NAME ": Failed connecting to internet service: %s.\n",
-		    str_error(rc));
+		printf(NAME ": Failed connecting to internet service (%d).\n",
+		    rc);
 		return 1;
 	}
